/////////////////////////////////////////////////////////////////////////////////
//
// Pgpb2.h
//
// Copyright(C) 2000 YUGA. All rights reserved.
//
/*
 * $Log: Pgpb2.h,v $
 * Revision 1.2  2000/11/07 15:57:18  syou
 * - PGPsdkpX[h͎ɍsĂZLeBtbNɂ镛pŁA
 *   MFCpWindow쐬Becky!AT[g邱Ƃh߂ɁAPGPB2
 *   }`XbhBāAversion 0.00.1̌ĂƂ
 *   ܂B
 *   [STLx[X̓ƎNXɕύXBsx̑̌ړI
 *   ƂāAVC++tSTLł͂ȂASTLport-4.0̗pB
 *   CO[Ů҂ɉ邽߁Aeo̓bZ[W\[Xɓ{ŏ
 *   ł̂AXɃ\[Xֈڂ͂߂Ă܂B
 *   PGP/MIMEbZ[W̌؂ƕɑΉ悤Ǝ݂iڂ͓
 *   vO\[XQƁjA،ʂ̕\@ɗǂ@v΂ȂB
 *   ACfAR[h΂肢܂B
 *
 */


#pragma once


/////////////////////////////////////////////////////////////////////////////////
//
#include <windows.h>
#include <pgpConfig.h>
#define PGP_WIN32 1
#include <pgpMemoryMgr.h>
#include <pgpPubTypes.h>
#include <pgpSDKPrefs.h>
#include <pgpKeys.h>
#include <pgpEncode.h>
#include <pgpUtilities.h>
#include <pgpErrors.h>
#include <pgpUserInterface.h>
#include <stdio.h>
#include <stdlib.h>
#include <mbstring.h>
#include <time.h>

#include "PgpMail.h"
#include "SignatureListener.h"
#include "DecryptListener.h"
#include "stringfr.h"


/////////////////////////////////////////////////////////////////////////////////
//
class Pgpb2
{
public:
    // Constructer
    Pgpb2(HINSTANCE initInstance);
    virtual ~Pgpb2();
    virtual void init();

    // PGPIy[V
    virtual bool encrypt(HWND hWnd, PGPContextRef context);
    virtual bool signing(HWND hWnd, PGPContextRef context);
    virtual bool encryptSigning(HWND hWnd, PGPContextRef context);
//    virtual bool publickey();
    virtual bool decodePgpMime(HWND hWnd, PGPContextRef context);
    //virtual bool decodeNotPgpMime(HWND hWnd, PGPContextRef context);
    virtual bool isPgpmime() { return pgpmime; }

    // mail
    virtual void setMail(PgpMail* newMail) { mail = newMail; }
    virtual PgpMail* getMail() { return mail; }

protected:

    // PGP Decode
    virtual bool decodePgpMailPart(BkMail* targetMailPart, HWND hWnd, PGPContextRef context);
    virtual bool decodePgpMailPart2(BkMail* targetMailPart, HWND hWnd, PGPContextRef context);
    virtual bool verifyPgpMimeMail(BkMail* targetMailPart, HWND hWnd, PGPContextRef context);
    virtual bool decryptPgpMimeMail(BkMail* targetMailPart, HWND hWnd, PGPContextRef context);
    virtual bool verifyDetachedSignature(PGPContextRef context, const string& body, const string& sign, SignatureListener& sigListener);
    virtual bool verifyAttachedSignature(PGPContextRef context, const string& pgp, SignatureListener& sigListener);
    virtual bool decrypt(PGPContextRef context, const string& pgp, DecryptListener& decListener, string& out);
    virtual bool explainSigningMessage(const SignatureListener& sigListener, string& out);

    // PGP Utility
    virtual int addAddressList(CPointerList& plstAddr, const string& toccbcc);
    virtual bool getKeySet(CPointerItem* pItem, PGPContextRef context, PGPKeySetRef& foundUserKeys);
    virtual BOOL getHashAlgorithm(PGPKeyRef& signingKey, LPSTR lpHash);

private:
    HINSTANCE instance;
    B2API* b2api;
    PgpMail* mail;
    bool pgpmime;

    stringfr version;
};


/////////////////////////////////////////////////////////////////////////////////
//
