////////////////////////////////////////////////////////////////////////////////////
//
// Pgpb2Decode.cpp
//
// Copyright (C) 2000 YUGA. All rights reserved.
//
/*
 * $Log: Pgpb2Decode.cpp,v $
 * Revision 1.4  2000/11/07 15:57:19  syou
 * - PGPsdkpX[h͎ɍsĂZLeBtbNɂ镛pŁA
 *   MFCpWindow쐬Becky!AT[g邱Ƃh߂ɁAPGPB2
 *   }`XbhBāAversion 0.00.1̌ĂƂ
 *   ܂B
 *   [STLx[X̓ƎNXɕύXBsx̑̌ړI
 *   ƂāAVC++tSTLł͂ȂASTLport-4.0̗pB
 *   CO[Ů҂ɉ邽߁Aeo̓bZ[W\[Xɓ{ŏ
 *   ł̂AXɃ\[Xֈڂ͂߂Ă܂B
 *   PGP/MIMEbZ[W̌؂ƕɑΉ悤Ǝ݂iڂ͓
 *   vO\[XQƁjA،ʂ̕\@ɗǂ@v΂ȂB
 *   ACfAR[h΂肢܂B
 *
 */


#pragma warning(push)
#pragma warning(disable:4101)
#pragma warning(disable:4786)


////////////////////////////////////////////////////////////////////////
//
#include "Pgpb2.h"


////////////////////////////////////////////////////////////////////////
//
Pgpb2::Pgpb2(HINSTANCE initInstance)
    : version(initInstance, 11)
{
    instance = initInstance;
    b2api = B2API::Instance();
    init();
}


Pgpb2::~Pgpb2()
{
    mail = NULL;
}


void Pgpb2::init()
{
    mail = NULL;
    pgpmime = true;
}


////////////////////////////////////////////////////////////////////////
// Decode
/**
 * PGP MIME decode
 */
bool Pgpb2::decodePgpMime(HWND hWnd, PGPContextRef context)
{
    // multipartAsignedtypemime part
    bool decode = decodePgpMailPart(mail, hWnd, context);

    /* // for Test
    if (bDecode) {
        LPSTR lpTempSource = mail.ToString();
        FILE* fp;
        fp = fopen("E:\\syou\\mail.txt", "wb");
        fwrite(lpTempSource, strlen(lpTempSource), 1, fp);
        fclose(fp);
        if (lpTempSource == NULL) {
            return FALSE;
        }
        m_pbka->SetSource("TEMP", lpTempSource);
        free(lpTempSource);
    }
    */

    return decode;
}


/**
 * PGP NOT MIME decode
 *//*
bool Pgpb2::decodeNotPgpMime(HWND hWnd, PGPContextRef context)
{
    bool result = false;
    string text = mail->getText();
    do {
        string::size_type pos_begin = text.find_first_of("-----BEGIN PGP ", 0, 15);
        if (pos_begin == string::npos) {
            pos_begin = text.find("\n-----BEGIN PGP ", 0, 16);
            if (pos_begin == string::npos) {
                return result;
            }
        }

        bool decrypt = true;
        bool sign = false;
        if (text.compare(pos_begin, 36, "-----BEGIN PGP PUBLIC KEY BLOCK-----") == 0) {
            decrypt = false;
        }
        else if (text.compare(pos_begin, 34, "-----BEGIN PGP SIGNED MESSAGE-----") == 0) {
            sign = true;
        }
        else {
            return result;
        }

        string::size_type pos_end = text.find("\n-----END PGP ", pos_begin);
        if (pos_end == string::npos) {
            return result;
        }

        string pgp = text.substr(pos_begin, pos_end - pos_begin + 1);

        DecryptListener decListener;
        decListener.setWindowHandle(hWnd);

        if (decrypt && !sign) {
            if (decrypt(context, pgp, decListener, out)) {
                text += out;
                result = true;
            }
        }
        else if (!decrypt && sign) {
            if (verifyAttachedSignature(context, pgp, decListener)) {
                result = true;
            }
        }
        if (decListener.isSigned()) {
            BkMail outMail;
            if (explainSigningMessage(decListener, outMail)) {
            }
        }
    } while (true);
}
//*/

////////////////////////////////////////////////////////////////////////
// find PGP MIME
bool Pgpb2::decodePgpMailPart(BkMail* targetMailPart, HWND hWnd, PGPContextRef context)
{
    bool decode = false;
    decode = decodePgpMailPart2(targetMailPart, hWnd, context);

    BkMailList::iterator first = targetMailPart->findMimeItem("message", "rfc822", FINDMIMEITEM_DEFAULT);
    BkMailList::iterator end = targetMailPart->end();
    for (; first != end; ++first) {
        BkMail* parent = *first;
        BkMail* rfc822;
        rfc822 = parent->getRfc822();
        if (rfc822) {
            if (decodePgpMailPart(rfc822, hWnd, context)) {
                string source = rfc822->toString();
                parent->clearBody();
                parent->pushBodyBack(source);
                decode = true;
            }
            delete rfc822;
        }
    }
    return decode;
}


bool Pgpb2::decodePgpMailPart2(BkMail* targetMailPart, HWND hWnd, PGPContextRef context)
{
    bool decode = false;
    BkMailList::iterator first = targetMailPart->findMimeItem("multipart", "encrypted", FINDMIMEITEM_DEFAULT);
    BkMailList::iterator end = targetMailPart->end();
    while (first != end) {
        if (decryptPgpMimeMail(*first, hWnd, context)) {
            first = targetMailPart->findMimeItem("multipart", "encrypted", FINDMIMEITEM_DEFAULT);
            end = targetMailPart->end();
            decode |= true;
        }
        else {
            ++first;
        }
    }
    first = targetMailPart->findMimeItem("multipart", "signed", FINDMIMEITEM_DEFAULT);
    for (; first != end; ++first) {
        decode |= verifyPgpMimeMail(*first, hWnd, context);
    }

    return decode;
}


////////////////////////////////////////////////////////////////////////
// PGP
bool Pgpb2::verifyPgpMimeMail(BkMail* targetMailPart, HWND hWnd, PGPContextRef context)
{
    // MIMEACeAPGP/MIMEp[gT
    //
    // PGP/MIME͉̎L̂悤ȃC[W
    // mail: ep[g
    //    child1: {iꂽbZ[WjFmailgetChild()Ŏ擾
    //    child2: child1getNext()Ŏ擾
    BkMail* child1;
    child1 = targetMailPart->getChild();
    if (child1 == NULL || child1->isMime("application", "pgp-signature")) {
        return false;
    }

    BkMail* child2;
    child2 = child1->getNext();
    if (child2 == NULL || !child2->isMime("application", "pgp-signature")) {
        return false;
    }

    // PGP/MIMEp[g̃\[X擾
    string pgp = child2->toString();

    // ۂɏ݂邩A擪"-----BEGIN PGP SIGNATURE-----"݂̑mF
    string::size_type pos = pgp.find("-----BEGIN PGP SIGNATURE-----");
    if (pos == string::npos) {
        return false;
    }

    // ̃\[X擾
    string sign = pgp.substr(pos);

    // {̃\[X擾
    string body;
    body = child1->toString();
    if (body.empty()) {
        return false;
    }

    // ؂̎s
    SignatureListener sigListener;
    if (!verifyDetachedSignature(context, body, sign, sigListener)) {
        return false;
    }

    // ،ʂ̉
    if (sigListener.isSigned()) {
        string out;
        if (explainSigningMessage(sigListener, out)) {
            stringfr mes(instance);
            BkMail* child3;
            string ctype = "multipart/mixed; boundary=\"" + targetMailPart->getBoundary() + "\"";
            targetMailPart->setHeader("Content-Type", ctype);
            //targetMailPart->setHeader("Content-Transfer-Encoding", "8bit");
            child3 = child1->setNext(new BkMail());
            child3->setHeader("Content-Type", "text/plain; charset=\"UTF-8\"");
            child3->setHeader("Content-Transfer-Encoding", "8bit");
            child3->pushBodyBack(out);
            child3->pushBodyBack(mes.getsfr(10)); //-- \nPGPB2 version 0.01.1\nhttp://www.ops.dti.ne.jp/~yuga/koubou/\n
        }
    }

    return true;
}


////////////////////////////////////////////////////////////////////////
// PGP
bool Pgpb2::decryptPgpMimeMail(BkMail* targetMailPart, HWND hWnd, PGPContextRef context)
{
    BkMail* child1;
    child1 = targetMailPart->getChild();
    if (child1 == NULL || !child1->isMime("application", "pgp-encrypted")) {
        return false;
    }

    BkMail* child2;
    child2 = child1->getNext();
    if (child2 == NULL || !child2->isMime("application", "octet-stream")) {
        return false;
    }

    // PGP/MIMËÍ̃\[X擾
    string encrypt = child2->toString();
    if (encrypt.empty()) {
        return false;
    }

    // Í̃\[X
    string::size_type pos = encrypt.find("-----BEGIN PGP ");
    if (pos == string::npos) {
        return false;
    }

    string pgp = encrypt.substr(pos);

    string out;
    DecryptListener decListener;
    decListener.setWindowHandle(hWnd);

    if (!decrypt(context, pgp, decListener, out)) {
        return false;
    }

    string ctype = "multipart/mixed; boundary=\"" + targetMailPart->getBoundary() + "\"";
    targetMailPart->setHeader("Content-Type", ctype);
    targetMailPart->setChild(new BkMail(out));

    /* Test validity of signature here */
    if (decListener.isSigned()) {
        if (explainSigningMessage(decListener, out)) {
            stringfr mes(instance);
            BkMail* child2;
            child2 = targetMailPart->addChild(new BkMail());
            child2->setHeader("Content-Type", "text/plain; charset=\"UTF-8\"");
            child2->setHeader("Content-Transfer-Encoding", "8bit");
            child2->pushBodyBack(out);
            child2->pushBodyBack(mes.getsfr(10)); //-- \nPGPB2 version 0.01.1\nhttp://www.ops.dti.ne.jp/~yuga/koubou/\n
        }
    }

    return true;
}


////////////////////////////////////////////////////////////////////////
//
/**
 * Detachedȏ̌
 */
bool Pgpb2::verifyDetachedSignature(PGPContextRef context, const string& body, const string& sign, SignatureListener& sigListener)
{
    bool result = false;
    PGPError err = kPGPError_NoErr;
    PGPKeySetRef defaultKeyRing = kInvalidPGPKeySetRef;

    err = PGPOpenDefaultKeyRings(context, kPGPKeyRingOpenFlags_Mutable, &defaultKeyRing);
    if (IsPGPError(err)) {
        return result;
    }

    err = PGPDecode(context,
            PGPOKeySetRef(context, defaultKeyRing),
            PGPOSetEventHandler(context, &sigListener),
            PGPOInputBuffer(context, sign.c_str(), sign.size()),
            PGPODetachedSig(context,
                PGPOInputBuffer(context, body.c_str(), body.size()),
                PGPOLastOption(context)),
            PGPOLastOption(context) );
    if (IsntPGPError(err)) {
        result = true;
    }

    if (PGPKeySetRefIsValid(defaultKeyRing)) {
        PGPFreeKeySet(defaultKeyRing);
    }

    return result;
}


/**
 * Attachedȏ̌
 */
bool Pgpb2::verifyAttachedSignature(PGPContextRef context, const string& pgp, SignatureListener& sigListener)
{
    bool result = false;
    PGPError err = kPGPError_NoErr;
    PGPKeySetRef defaultKeyRing = kInvalidPGPKeySetRef;

    err = PGPOpenDefaultKeyRings(context, kPGPKeyRingOpenFlags_Mutable, &defaultKeyRing);
    if (IsPGPError(err)) {
        return result;
    }

    err = PGPDecode(context,
            PGPOKeySetRef(context, defaultKeyRing),
            PGPOSetEventHandler(context, &sigListener),
            PGPOInputBuffer(context, pgp.c_str(), pgp.size()),
            PGPOLastOption(context) );
    if (IsntPGPError(err)) {
        result = true;
    }

    if (PGPKeySetRefIsValid(defaultKeyRing)) {
        PGPFreeKeySet(defaultKeyRing);
    }

    return result;
}


/**
 * 
 */
bool Pgpb2::decrypt(PGPContextRef context, const string& pgp, DecryptListener& decListener, string& out)
{
    bool result = false;
    PGPError err = kPGPError_NoErr;
    PGPKeySetRef defaultKeyRing = kInvalidPGPKeySetRef;

    err = PGPOpenDefaultKeyRings(context, kPGPKeyRingOpenFlags_Mutable, &defaultKeyRing);
    if (IsPGPError(err)) {
        return result;
    }

    LPSTR lpArea = NULL;
    PGPSize outputSize = 0;

    err = PGPDecode(context,
            PGPOInputBuffer(context, pgp.c_str(), pgp.size()),
            PGPOAllocatedOutputBuffer(context, reinterpret_cast<void**>(&lpArea), MAX_PGPInt32, &outputSize),
            PGPOKeySetRef(context, defaultKeyRing),
            PGPOSetEventHandler(context, &decListener),
            PGPOLastOption(context)
            );
    if (IsntPGPError(err)) {
        result = true;
    }

    if (lpArea) {
        out.assign(lpArea);
        PGPFreeData(lpArea);
    }

    if (PGPKeySetRefIsValid(defaultKeyRing)) {
        PGPFreeKeySet(defaultKeyRing);
    }

    return result;
}


////////////////////////////////////////////////////////////////////////
// ̐}
bool Pgpb2::explainSigningMessage(const SignatureListener& sigListener, string& out)
{
    /* Test validity of signature here */
    if (!sigListener.isSigned()) {
        return false;
    }

    char szBuf[32768];

    // PGPB2̃bZ[W
    stringfr mes(instance);
    stringfr result(instance);
    result += mes.getsfr(1); //"̃[PGP/MIMEĂ܂B"
    result += "\r\n";

    if (sigListener.isChecked())
    {
        /* There was a signature in the file */
        if (sigListener.isVerified())
        {
            /* The signature verified */
            char szBufGmt[1024];
            char szBufLmt[1024];
            time_t creationTime;

            sprintf(szBuf, mes.getsfr(2).c_str(), sigListener.getName()); //"%s̐łB\r\n"
            result += szBuf;
            result += "\r\n";
            creationTime = PGPGetStdTimeFromPGPTime(sigListener.getData().creationTime);
            strftime(szBufGmt, 1024, mes.getsfr(3).c_str(), gmtime(&creationTime)); //"%Y/%m/%d %H:%M:%S GMT"
            strftime(szBufLmt, 1024, mes.getsfr(4).c_str(), localtime(&creationTime)); //"%Y/%m/%d %H:%M:%S %Z"
            sprintf(szBuf, mes.getsfr(5).c_str(), szBufGmt, szBufLmt); //" %s (%s) ɍ쐬܂B"
            result += szBuf;
            result += "\r\n";
        }
        else
        {
            sprintf(szBuf, mes.getsfr(6).c_str(), sigListener.getName()); //"%s̕sȏłB"
            result += szBuf;
            result += mes.getsfr(7); //"{̓eƏv܂B"
        }
    }
    else {
        switch (sigListener.getKeyValidity()) {
        case kPGPValidity_Unknown:
            strcpy(szBuf, mes.getsfr(8).c_str()); //"̏؂邽߂̌J܂B"
            break;
        case kPGPValidity_Marginal:
        case kPGPValidity_Invalid:
            strcpy(szBuf, mes.getsfr(9).c_str()); //"sȏłB"
        default:
            strcpy(szBuf, "");
            break;
        }

        result += szBuf;
    }

    out = result.utf8();

    return true;
}


////////////////////////////////////////////////////////////////////////
//
#pragma warning(pop) /* restore previous warning */
