/////////////////////////////////////////////////////////////////////////////////
//
// Pgpb2Thread.h
//
// Copyright(C) 2000 YUGA. All rights reserved.
//
/*
 * $Log: Pgpb2Thread.h,v $
 * Revision 1.1  2000/11/07 15:57:19  syou
 * - PGPsdkpX[h͎ɍsĂZLeBtbNɂ镛pŁA
 *   MFCpWindow쐬Becky!AT[g邱Ƃh߂ɁAPGPB2
 *   }`XbhBāAversion 0.00.1̌ĂƂ
 *   ܂B
 *   [STLx[X̓ƎNXɕύXBsx̑̌ړI
 *   ƂāAVC++tSTLł͂ȂASTLport-4.0̗pB
 *   CO[Ů҂ɉ邽߁Aeo̓bZ[W\[Xɓ{ŏ
 *   ł̂AXɃ\[Xֈڂ͂߂Ă܂B
 *   PGP/MIMEbZ[W̌؂ƕɑΉ悤Ǝ݂iڂ͓
 *   vO\[XQƁjA،ʂ̕\@ɗǂ@v΂ȂB
 *   ACfAR[h΂肢܂B
 *
 *
 */


#pragma once


/////////////////////////////////////////////////////////////////////////////////
//
#include <windows.h>
#include <process.h>

#include <pgpConfig.h>
#define PGP_WIN32 1
#include <pgpMemoryMgr.h>
#include <pgpPubTypes.h>
#include <pgpSDKPrefs.h>
#include <pgpKeys.h>
#include <pgpEncode.h>
#include <pgpUtilities.h>
#include <pgpErrors.h>
#include <pgpUserInterface.h>
#include <stdio.h>
#include <stdlib.h>
#include <mbstring.h>
#include <time.h>
#include <map>

#include "Pgpb2.h"
#include "SignatureListener.h"
#include "DecryptListener.h"


/////////////////////////////////////////////////////////////////////////////////
//
using namespace std;


/////////////////////////////////////////////////////////////////////////////////
//
#define WM_PGPB2_ENCRYPT            WM_USER+1
#define WM_PGPB2_SIGINING           WM_USER+2
#define WM_PGPB2_ENCRYPTSIGINING    WM_USER+3
#define WM_PGPB2_PUBLICKEY          WM_USER+4
#define WM_PGPB2_DECODEPGPMIME      WM_USER+5
#define WM_PGPB2_DECODENONPGPMIME   WM_USER+6


#define PGPB2_SETSOURCE             1
#define PGPB2_SETTEMPSOURCE         2
#define PGPB2_COMPSETSOURCE         3
#define PGPB2_COMPSETTEMPSOURCE     4
#define PGPB2_SETTEXT               5
#define PGPB2_SETTEMPTEXT           6
#define PGPB2_COMPSETTEXT           7
#define PGPB2_COMPSETTEMPTEXT       8


#define PGPB2_ENTERFALSE            0
#define PGPB2_ENTERTRUE             1


/////////////////////////////////////////////////////////////////////////////////
//
typedef map<DWORD, DWORD> MessageMap;


/////////////////////////////////////////////////////////////////////////////////
//
class Pgpb2Thread
{
public:
    explicit Pgpb2Thread(HINSTANCE initInstance, DWORD initTlsid);
    virtual ~Pgpb2Thread();

    bool pgpEncrypt(HWND hWnd, PgpMail* mail); // Í
    bool pgpSigning(HWND hWnd, PgpMail* mail); // 
    bool pgpEncryptSigning(HWND hWnd, PgpMail* mail); // ÍƏ
    bool pgpPublickey(HWND hWnd, PgpMail* mail); // JYt
    bool pgpDecodePgpMime(HWND hWnd, PgpMail* mail); // ƌ
    //bool pgpDecodeNonPgpMime(HWND hWnd, PgpMail* mail); // ƌ

    MessageMap& getMessageMap();
    PgpMail* getMail() { return pgpb2.getMail(); }
    void onExit();

protected:
    void main();
    ATOM registerWindowClass();
    bool initTls(Pgpb2Thread* pointer);
    bool initPGPContext();
    bool initWindow();
    void setRecipientWindow(HWND newRecipentWindow);
    LRESULT windowProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam);

    static void threadStart(void* threadObject);
    static LRESULT CALLBACK WndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam);

private:
    static DWORD tlsid;
    long enter;

    HINSTANCE instance;
    HWND recipentWindow;
    HWND windowOfPgpb2;
    MessageMap message;
    DWORD threadid;
    PGPContextRef context;
    Pgpb2 pgpb2;
};


/////////////////////////////////////////////////////////////////////////////////
//
