////////////////////////////////////////////////////////////////////////////////////
//
// main.cpp
//
// Copyright (C) 2000 YUGA. All rights reserved.
//
/*
 * $Log: main.cpp,v $
 * Revision 1.20  2000/11/07 15:57:20  syou
 * - PGPsdkpX[h͎ɍsĂZLeBtbNɂ镛pŁA
 *   MFCpWindow쐬Becky!AT[g邱Ƃh߂ɁAPGPB2
 *   }`XbhBāAversion 0.00.1̌ĂƂ
 *   ܂B
 *   [STLx[X̓ƎNXɕύXBsx̑̌ړI
 *   ƂāAVC++tSTLł͂ȂASTLport-4.0̗pB
 *   CO[Ů҂ɉ邽߁Aeo̓bZ[W\[Xɓ{ŏ
 *   ł̂AXɃ\[Xֈڂ͂߂Ă܂B
 *   PGP/MIMEbZ[W̌؂ƕɑΉ悤Ǝ݂iڂ͓
 *   vO\[XQƁjA،ʂ̕\@ɗǂ@v΂ȂB
 *   ACfAR[h΂肢܂B
 *
 *
 */


#pragma warning(push)
#pragma warning(disable:4101)
#pragma warning(disable:4786)


/////////////////////////////////////////////////////////////////////////////
//
#include "main.h"


/////////////////////////////////////////////////////////////////////////////
//
HINSTANCE instance = NULL;
DWORD tlsid = NULL;
B2API* b2api = NULL;
Pgpb2Thread* pgpb2Thread = NULL;

char szIni[_MAX_PATH+2]; // Ini file to save your plugin settings.


/////////////////////////////////////////////////////////////////////////////
// DLL entry point
BOOL APIENTRY DllMain(HANDLE hModule, DWORD  ul_reason_for_call, LPVOID lpReserved)
{
    instance = (HINSTANCE)hModule;
    switch (ul_reason_for_call)
    {
        case DLL_PROCESS_ATTACH:
            {
                // memory leak p
                _CrtSetDbgFlag(_CRTDBG_LEAK_CHECK_DF | _CRTDBG_ALLOC_MEM_DF);
                //_CrtSetBreakAlloc(865);  // Yԍ̃mێbreak

                // B2 PlugIn API 
                b2api = B2API::Instance();
                if (b2api == NULL) {
                    return FALSE;
                }

                // PGPsdk libs
                PGPError err = PGPsdkInit();
                if(IsPGPError(err)) {
                    return FALSE;
                }

                // PGPsdk UI libs
                err = PGPsdkUILibInit();
                if (IsPGPError(err)) {
                    return FALSE;
                }

                tlsid = TlsAlloc();
                if (tlsid == TLS_OUT_OF_INDEXES) {
                    return FALSE;
                }

                // Pgpb2
                pgpb2Thread = new Pgpb2Thread(instance, tlsid);
                if (pgpb2Thread == NULL) {
                    return FALSE;
                }
            }
            break;
        case DLL_THREAD_ATTACH:
           break;
        case DLL_THREAD_DETACH:
            break;
        case DLL_PROCESS_DETACH:
            {
                // Pgpb2I
                delete pgpb2Thread;

                // Tls
                TlsFree(tlsid);

                // PGPsdk UI libsI
                PGPsdkUILibCleanup();

                // PGPsdk libsI
                PGPsdkCleanup();

                // B2 PlugIn APII
                delete b2api;
            }
            break;
    }
    return TRUE;
}


/////////////////////////////////////////////////////////////////////////////////////////////
// Callbacks from Becky!

#ifdef __cplusplus
extern "C"{
#endif

////////////////////////////////////////////////////////////////////////
// Called when the program is started and the main window is created.
int WINAPI BKC_OnStart()
{
    // Always return 0.
    return 0;
}

////////////////////////////////////////////////////////////////////////
// Called when the main window is closing.
int WINAPI BKC_OnExit()
{
    // XbhI
    pgpb2Thread->onExit();

    // Return -1 if you don't want to quit.
    return 0;
}

////////////////////////////////////////////////////////////////////////
// Called when menu is intialized.
int WINAPI BKC_OnMenuInit(HWND hWnd, HMENU hMenu, int nType)
{
/*
PGPB2_SETTEXT
PGPB2_COMPSETTEMPSOURCE
PGPB2_COMPSETTEMPTEXT*/
    switch (nType) {
    case BKC_MENU_MAIN:
        {
            // Adding menu items
            HMENU hSubMenu = GetSubMenu(hMenu, 4);
            AppendMenu(hSubMenu, MF_SEPARATOR, 0, NULL);
            // Define CmdProc as "void WINAPI CmdProc(HWND, LPARAM)"
            UINT nID = b2api->RegisterCommand("ҏW̃[PGP܂", nType, CmdProc5);
            AppendMenu(hSubMenu, MF_STRING, nID, "PGPB2: Decrypt and Verify (PGP/MIME Only)");

            //
            DWORD id = b2api->RegisterCommand("", nType, SetSource);
            MessageMap& message = pgpb2Thread->getMessageMap();
            message[PGPB2_SETSOURCE] = id;
            id = b2api->RegisterCommand("", nType, SetTempSource);
            message[PGPB2_SETTEMPSOURCE] = id;
            id = b2api->RegisterCommand("", nType, SetTempText);
            message[PGPB2_SETTEMPTEXT] = id;

            /*
            nID = b2api->RegisterCommand("B2쌟ؗpR}hł: XbhJn", nType, CmdProc21);
            AppendMenu(hSubMenu, MF_STRING, nID, "PGPB2: B2쌟");
            */
        }
        break;
    case BKC_MENU_LISTVIEW:
        break;
    case BKC_MENU_TREEVIEW:
        break;
    case BKC_MENU_MSGVIEW:
        break;
    case BKC_MENU_MSGEDIT:
        break;
    case BKC_MENU_COMPOSE:
        {
            // Sample of adding menu items
            HMENU hSubMenu = GetSubMenu(hMenu, 3);
            AppendMenu(hSubMenu, MF_SEPARATOR, 0, NULL);
            // Define CmdProc as "void WINAPI CmdProc(HWND, LPARAM)"
            UINT nID = b2api->RegisterCommand("ҏW̃[PGPÍ܂", nType, CmdProc1);
            AppendMenu(hSubMenu, MF_STRING, nID, "PGPB2: Encrypt");
            nID = b2api->RegisterCommand("ҏW̃[PGP܂", nType, CmdProc2);
            AppendMenu(hSubMenu, MF_STRING, nID, "PGPB2: Sign");
            nID = b2api->RegisterCommand("ҏW̃[PGPĈÍ܂", nType, CmdProc3);
            AppendMenu(hSubMenu, MF_STRING, nID, "PGPB2: Sign and Encrypt");
            //nID = b2api->RegisterCommand("ҏW̃[ɌJYt܂", nType, CmdProc4);
            //AppendMenu(hSubMenu, MF_STRING, nID, "PGPB2: J̓Yt");
            
            DWORD id;
            id = b2api->RegisterCommand("", nType, CompSetSource);
            MessageMap& message = pgpb2Thread->getMessageMap();
            message[PGPB2_COMPSETSOURCE] = id;
            id = b2api->RegisterCommand("", nType, CompSetText);
            message[PGPB2_COMPSETTEXT] = id;
            /*
            nID = b2api->RegisterCommand("B2쌟ؗpR}hł", nType, CmdProc9);
            AppendMenu(hSubMenu, MF_STRING, nID, "PGPB2: B2쌟");

            nID = b2api->RegisterCommand("B2쌟ؗpR}hł2", nType, CmdProc8);
            AppendMenu(hSubMenu, MF_STRING, nID, "PGPB2: B2쌟");
            */
        }
        break;
    case BKC_MENU_COMPEDIT:
        break;
    case BKC_MENU_COMPREF:
        break;
    default:
        break;
    }
    // Always return 0.
    return 0;
}

////////////////////////////////////////////////////////////////////////
// Called when a folder is opened.
int WINAPI BKC_OnOpenFolder(LPCTSTR lpFolderID)
{
    // Always return 0.
    return 0;
}

////////////////////////////////////////////////////////////////////////
// Called when a mail is selected.
int WINAPI BKC_OnOpenMail(LPCTSTR lpMailID)
{
    // Always return 0.
    return 0;
}

////////////////////////////////////////////////////////////////////////
// Called every minute.
int WINAPI BKC_OnEveryMinute()
{
    // Always return 0.
    return 0;
}

////////////////////////////////////////////////////////////////////////
// Called when a compose windows is opened.
int WINAPI BKC_OnOpenCompose(HWND hWnd, int nMode/* See COMPOSE_MODE_* in BeckyApi.h */)
{
    // Always return 0.
    return 0;
}

////////////////////////////////////////////////////////////////////////
// Called when the composing message is saved.
int WINAPI BKC_OnOutgoing(HWND hWnd, int nMode/* 0:SaveToOutbox, 1:SaveToDraft, 2:SaveToReminder*/)
{
    // Return -1 if you do not want to send it yet.
    return 0;
}

////////////////////////////////////////////////////////////////////////
// Called when a key is pressed.
int WINAPI BKC_OnKeyDispatch(HWND hWnd, int nKey/* virtual key code */, int nShift/* Shift state. 0x40=Shift, 0x20=Ctrl, 0x60=Shift+Ctrl, 0xfe=Alt*/)
{
    // Return TRUE if you want to suppress subsequent command associated to this key.
    return 0;
}

////////////////////////////////////////////////////////////////////////
// Called when a message is retrieved and saved to a folder
int WINAPI BKC_OnRetrieve(LPCTSTR lpMessage/* Message source*/, LPCTSTR lpMailID/* Mail ID*/)
{
    // Always return 0.
    return 0;
}

////////////////////////////////////////////////////////////////////////
// Called when a message is spooled
int WINAPI BKC_OnSend(LPCTSTR lpMessage/* Message source */)
{
    // Always return 0.
    return 0;
}

////////////////////////////////////////////////////////////////////////
// Called when all messages are retrieved
int WINAPI BKC_OnFinishRetrieve(int nNumber/* Number of messages*/)
{
    // Always return 0.
    return 0;
}


////////////////////////////////////////////////////////////////////////
// Called when plug-in setup is needed.
int WINAPI BKC_OnPlugInSetup(HWND hWnd)
{
    // Return nonzero if you have processed.
    // return 1;
    return 0;
}


////////////////////////////////////////////////////////////////////////
// Called when plug-in information is being retrieved.
typedef struct tagBKPLUGININFO
{
    char szPlugInName[80]; // Name of the plug-in
    char szVendor[80]; // Name of the vendor
    char szVersion[80]; // Version string
    char szDescription[256]; // Short description about this plugin
} BKPLUGININFO, *LPBKPLUGININFO;


int WINAPI BKC_OnPlugInInfo(LPBKPLUGININFO lpPlugInInfo)
{
    /* You MUST specify at least szPlugInName and szVendor.
       otherwise Becky! will silently ignore your plug-in.*/
    strcpy(lpPlugInInfo->szPlugInName, "PGP PlugIn for B2");
    strcpy(lpPlugInInfo->szVendor, "YUGA");
    strcpy(lpPlugInInfo->szVersion, "version 0.01.1");
    strcpy(lpPlugInInfo->szDescription, "B2GUIPGPvOCłBPGP version 6.5.x ΉlĂ܂B");
    // Always return 0.
    return 0;
}


////////////////////////////////////////////////////////////////////////
//
void WINAPI CmdProc1(HWND hWnd, LPARAM lParam)
{
    // Í
    b2mailstream mailstream(hWnd, ios_base::in);
    PgpMail *mail = new PgpMail();
    char szMimeType[80];
    char szCharset[80];
    try {
        mailstream >> *mail;
        b2api->CompGetCharSet(hWnd, szCharset, 80);
        mail->setText(preSetText(b2api->CompGetText(hWnd, szMimeType, 80), szCharset));
        if (!pgpb2Thread->pgpEncrypt(hWnd, mail)) {
            b2api->SetMessageText(hWnd, "Pgpb2́AxɕPGPF߂ȂdlƂȂĂ܂B");
        }
    }
    catch (...) {
    }
    EnableWindow(hWnd, TRUE);
}


void WINAPI CmdProc2(HWND hWnd, LPARAM lParam)
{
    // 
    b2mailstream mailstream(hWnd, ios_base::in);
    PgpMail *mail = new PgpMail();
    char szMimeType[80];
    char szCharset[80];
    try {
        mailstream >> *mail;
        b2api->CompGetCharSet(hWnd, szCharset, 80);
        mail->setText(preSetText(b2api->CompGetText(hWnd, szMimeType, 80), szCharset));
        /*
        FILE* fp;
        string text(b2api->CompGetSource(hWnd));
        fp = fopen("E:\\syou\\mail0.txt", "wb");
        fwrite(text.c_str(), text.size(), 1, fp);
        fclose(fp);
        //*/
        if (!pgpb2Thread->pgpSigning(hWnd, mail)) {
            b2api->SetMessageText(hWnd, "Pgpb2́AxɕPGPF߂ȂdlƂȂĂ܂B");
        }
    }
    catch (...) {
    }
}


void WINAPI CmdProc3(HWND hWnd, LPARAM lParam)
{
    // ƈÍ
    b2mailstream mailstream(hWnd, ios_base::in);
    PgpMail *mail = new PgpMail();
    char szMimeType[80];
    char szCharset[80];
    try {
        mailstream >> *mail;
        b2api->CompGetCharSet(hWnd, szCharset, 80);
        mail->setText(preSetText(b2api->CompGetText(hWnd, szMimeType, 80), szCharset));
        if (!pgpb2Thread->pgpEncryptSigning(hWnd, mail)) {
            b2api->SetMessageText(hWnd, "Pgpb2́AxɕPGPF߂ȂdlƂȂĂ܂B");
        }
    }
    catch (...) {
    }
}

/*
void WINAPI CmdProc4(HWND hWnd, LPARAM lParam)
{
    // JYt
    b2mailstream mailstream(hWnd, ios_base::in);
    PgpMail *mail = new PgpMail();
    mailstream >> *mail;
    try {
        if (!pgpb2Thread->pgpPublickey(hWnd, mail)) {
            b2api->SetMessageText(hWnd, "Pgpb2́AxɕPGPF߂ȂdlƂȂĂ܂B");
        }
    }
    catch (...) {
    }
}
*/

void WINAPI CmdProc5(HWND hWnd, LPARAM lParam)
{
    // ƌ PGP MIME
    b2mailstream mailstream(b2api->GetCurrentMail(), ios_base::in);
    PgpMail *mail = new PgpMail();
    try {
        mailstream >> *mail;
        if (!pgpb2Thread->pgpDecodePgpMime(hWnd, mail)) {
            b2api->SetMessageText(hWnd, "Pgpb2́AxɕPGPF߂ȂdlƂȂĂ܂B");
        }
    }
    catch (...) {
    }
}

/*
void WINAPI CmdProc6(HWND hWnd, LPARAM lParam)
{
    // ƌ non PGP MIME
    b2mailstream mailstream(b2api->GetCurrentMail(), ios_base::in);
    PgpMail *mail = new PgpMail();
    char szMimeType[80];
    char szCharset[80];
    try {
        mailstream >> *mail;
        b2api->CompGetCharSet(hWnd, szCharset, 80);
        mail->setText(preSetText(b2api->CompGetText(hWnd, szMimeType, 80), szCharset));
        if (!pgpb2Thread->pgpDecode(hWnd, mail)) {
            b2api->SetMessageText(hWnd, "Pgpb2́AxɕPGPF߂ȂdlƂȂĂ܂B");
        }
    }
    catch (...) {
    }
}
*/

void WINAPI SetSource(HWND hWnd, LPARAM lParam)
{
    b2mailstream mailstream(b2api->GetCurrentMail(), ios_base::out);
    PgpMail *mail = pgpb2Thread->getMail();
    try {
        mailstream << *mail;
        mailstream.flush();
    }
    catch (...) {
    }
}


void WINAPI SetTempSource(HWND hWnd, LPARAM lParam)
{
    b2mailstream mailstream("TEMP", ios_base::out);
    PgpMail *mail = pgpb2Thread->getMail();
    try {
        mailstream << *mail;
        mailstream.flush();
    }
    catch (...) {
    }
}


void WINAPI CompSetSource(HWND hWnd, LPARAM lParam)
{
    b2mailstream mailstream(hWnd, ios_base::out);
    PgpMail *mail = pgpb2Thread->getMail();
    try {
        EnableWindow(hWnd, TRUE);
        /*
        FILE* fp;
        string text = mail->toString();
        fp = fopen("E:\\syou\\mail2.txt", "wb");
        fwrite(text.c_str(), text.size(), 1, fp);
        fclose(fp);
        //*/
        mailstream << *mail;
        mailstream.flush();
        b2api->Command(hWnd, "TextTop");
    }
    catch (exception& e) {
        LPCTSTR m = e.what();
    }
}


void WINAPI CompSetText(HWND hWnd, LPARAM lParam)
{
    PgpMail *mail = pgpb2Thread->getMail();
    b2api->CompSetText(hWnd, 0, mail->getText().c_str());
}


void WINAPI SetTempText(HWND hWnd, LPARAM lParam)
{
    PgpMail *mail = pgpb2Thread->getMail();
    b2api->SetText(-2, mail->getText().c_str());
}


#ifdef __cplusplus
}
#endif


////////////////////////////////////////////////////////////////////////
//
string preSetText(const string& text, const string& charset)
{
    if (stricmp(charset.c_str(), "ISO-2022-JP") == 0 || (charset.size() == 0 && GetACP() == 932)) {
        return string(b2api->ISO_2022_JP(text.c_str(), TRUE));
    }
    return text;
}


#pragma warning(pop) /* restore previous warning */
