/////////////////////////////////////////////////////////////////////////////////
//
// countptr.h
//
// Copyright (C) 2000 YUGA. All rights reserved.
//
/*
 * $Log: b2mailstream.h,v $
 * Revision 1.1  2000/11/07 15:57:20  syou
 * - PGPsdkpX[h͎ɍsĂZLeBtbNɂ镛pŁA
 *   MFCpWindow쐬Becky!AT[g邱Ƃh߂ɁAPGPB2
 *   }`XbhBāAversion 0.00.1̌ĂƂ
 *   ܂B
 *   [STLx[X̓ƎNXɕύXBsx̑̌ړI
 *   ƂāAVC++tSTLł͂ȂASTLport-4.0̗pB
 *   CO[Ů҂ɉ邽߁Aeo̓bZ[W\[Xɓ{ŏ
 *   ł̂AXɃ\[Xֈڂ͂߂Ă܂B
 *   PGP/MIMEbZ[W̌؂ƕɑΉ悤Ǝ݂iڂ͓
 *   vO\[XQƁjA،ʂ̕\@ɗǂ@v΂ȂB
 *   ACfAR[h΂肢܂B
 *
 */

#pragma once
#pragma warning(push)
#pragma warning(disable:4101)
#pragma warning(disable:4290)
#pragma warning(disable:4786)


/////////////////////////////////////////////////////////////////////////////////
//
#include <sstream>
#include "B2API.h"


/////////////////////////////////////////////////////////////////////////////////
//
using namespace std;


/////////////////////////////////////////////////////////////////////////////////
//
enum __Strstate {_Allocated = 1, _Constant = 2, _Noread = 4};
_BITMASK(__Strstate, _Strstate);
_BITMASK_OPS(__Strstate)

/////////////////////////////////////////////////////////////////////////////////
//
template<class _E,
    class _Tr = char_traits<_E>,
    class _A = allocator<_E> >
    class basic_b2mailbuf : public basic_stringbuf<_E, _Tr, _A> {
public:
    typedef basic_stringbuf<_E, _Tr, _A> _Super;
    typedef basic_string<_E, _Tr, _A> _Mystr;
    explicit basic_b2mailbuf(
            ios_base::openmode _W = ios_base::in | ios_base::out)
            {_InitAPI();
            _Super::_Init(0, 0, _Mode(_W)); }
    /**Composep*/
    explicit basic_b2mailbuf(HWND _InitWnd,
            ios_base::openmode _W = ios_base::in | ios_base::out)
            {try
                {_InitAPI();
                _Init(_InitWnd, _W); }
            catch (runtime_error& _err)
                {_Super::_Init(0, 0, _Mode(_W)); }}
    /**ComposepA\[Xi[*/
    basic_b2mailbuf(HWND _InitWnd,
            _Mystr _InitS,
            ios_base::openmode _W = ios_base::in | ios_base::out)
            {_InitAPI();
            _Wnd = _InitWnd;
            _Belong = _Compose;
            _Super::_Init(_InitS.c_str(), _InitS.size(), _Mode(_W)); }
    /**Mail viewp*/
    basic_b2mailbuf(_Mystr _InitMid,
            ios_base::openmode _W = ios_base::in | ios_base::out)
            {try
                {_InitAPI();
                _Init(_InitMid, _W); }
            catch (runtime_error& _err)
            {_Super::_Init(0, 0, _Mode(_W)); }}
    /**Mail viewpA\[Xi[*/
    explicit basic_b2mailbuf(_Mystr _InitMid,
            _Mystr _InitS,
            ios_base::openmode _W = ios_base::in | ios_base::out)
            {_InitAPI();
            _Mid = _InitMid;
            _Belong = _MailView;
            _Super::_Init(_InitS.c_str(), _InitS.size(), _Mode(_W)); }
    virtual ~basic_b2mailbuf()
            {}
protected:
        virtual int sync()
        {if (_Belong == _Compose)
            _B2->CompSetSource(_Wnd, str().c_str());
        else
            _B2->SetSource(_Mid.c_str(), str().c_str());
        return 0; }
    void _InitAPI()
        {_B2 = B2API::Instance(); }
    void _Init(HWND _InitWnd, ios_base::openmode _W)
        throw(runtime_error)
        {_Wnd = _InitWnd;
        _Belong = _Compose;
        try
            {_Mystr _S = _GetSource();
            _Super::_Init(_S.c_str(), _S.size(), _Mode(_W)); }
        catch (logic_error& _err)
            {_Super::_Init(0, 0, _Mode(_W)); }}
    void _Init(const _Mystr& _InitMid, ios_base::openmode _W)
        throw(runtime_error)
        {_Mid = _InitMid;
        _Belong = _MailView;
        try
            {_Mystr _S = _GetSource();
            _Super::_Init(_S.c_str(), _S.size(), _Mode(_W)); }
        catch (logic_error& _err)
            {_Super::_Init(0, 0, _Mode(_W)); }}
    _Mystr _GetSource()
        throw(logic_error, runtime_error)
        {if (_Belong == _None)
            throw logic_error("Not attached to B2");
        _E* _S = (_Belong == _Compose) ?
            _B2->CompGetSource(_Wnd) : _B2->GetSource(_Mid.c_str());
        if (!_S)
            throw runtime_error("B2 inner error");
        return _Mystr(_S); }
private:
    enum _BelongState {_None = 0, _Compose = 1, _MailView = 2 };
    _Strstate _Mode(ios_base::openmode _W)
            {_Strstate _St = (_Strstate)0;
            if (!(_W & ios_base::in))
                    _St |= _Noread;
            if (!(_W & ios_base::out))
                    _St |= _Constant;
            return (_St); }
    B2API* _B2;
    HWND _Wnd;
    _Mystr _Mid;
    _BelongState _Belong;
    };


/////////////////////////////////////////////////////////////////////////////////
//
template<class _E,
    class _Tr = char_traits<_E>,
    class _A = allocator<_E> >
    class basic_b2mailstream : public basic_iostream<_E, _Tr> {
public:
    typedef basic_string<_E, _Tr, _A> _Mystr;
    /**Composep*/
    explicit basic_b2mailstream(HWND _Wnd, openmode _W = in | out)
            : basic_iostream<_E, _Tr>(&_Sb), _Sb(_Wnd, _W) {}
    /**ComposepA\[Xi[*/
    explicit basic_b2mailstream(HWND _Wnd, _Mystr _InitS, openmode _W = in | out)
            : basic_iostream<_E, _Tr>(&_Sb), _Sb(_Wnd, _InitS, _W) {}
    /**Mail viewp*/
    explicit basic_b2mailstream(_Mystr _Mid, openmode _W = in | out)
            : basic_iostream<_E, _Tr>(&_Sb), _Sb(_Mid, _W) {}
    /**Mail viewpA\[Xi[*/
    explicit basic_b2mailstream(_Mystr _Mid, _Mystr _InitS, openmode _W = in | out)
            : basic_iostream<_E, _Tr>(&_Sb), _Sb(_Mid, _InitS, _W) {}
    virtual ~basic_b2mailstream()
            {}
    basic_b2mailbuf<_E, _Tr, _A> *rdbuf() const
            {return ((basic_b2mailbuf<_E, _Tr, _A> *)&_Sb); }
    _Mystr str() const
            {return (_Sb.str()); }
    void str(const _Mystr& _S)
            {_Sb.str(_S); }
private:
    basic_b2mailbuf<_E, _Tr, _A> _Sb;
    };


/////////////////////////////////////////////////////////////////////////////////
//
typedef basic_b2mailbuf<char> b2mailbuf;
typedef basic_b2mailstream<char> b2mailstream;


